"""Initial migration

Revision ID: 15bc4ace8bbd
Revises:
Create Date: 2023-07-09 17:18:52.938572

"""

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "15bc4ace8bbd"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "admin",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("email", sa.String(length=64), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("last_login", sa.DateTime(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "relay",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_exit", sa.Boolean(), nullable=False),
        sa.Column("fingerprint", sa.String(length=40), nullable=False),
        sa.Column("first_seen", sa.DateTime(), nullable=False),
        sa.Column("last_seen", sa.DateTime(), nullable=False),
        sa.Column("version", sa.String(length=32), nullable=True),
        sa.Column("recommended_version", sa.Boolean(), nullable=False),
        sa.Column("is_up", sa.Boolean(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("fingerprint"),
    )
    op.create_table(
        "subscriber",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("email", sa.String(length=64), nullable=False),
        sa.Column("password", sa.String(length=64), nullable=False),
        sa.Column("is_confirmed", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "subscription",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("is_family", sa.Boolean(), nullable=False),
        sa.Column("is_extended_family", sa.Boolean(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("subscriber_id", sa.Integer(), nullable=False),
        sa.Column("host_id", sa.Integer(), nullable=True),
        sa.Column("relay_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["host_id"],
            ["relay.id"],
        ),
        sa.ForeignKeyConstraint(
            ["relay_id"],
            ["relay.id"],
        ),
        sa.ForeignKeyConstraint(
            ["subscriber_id"],
            ["subscriber.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_bandwidth_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("threshold", sa.Float(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_down_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("running", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_flag_exit_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_flag_fast_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_flag_guard_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_flag_stable_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_flag_valid_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("wait_for", sa.Integer(), nullable=False),
        sa.Column("issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "node_version_sub",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("is_active", sa.Boolean(), nullable=False),
        sa.Column("created_on", sa.DateTime(), nullable=False),
        sa.Column("updated_on", sa.DateTime(), nullable=False),
        sa.Column("eol_issue_first_seen", sa.DateTime(), nullable=True),
        sa.Column("eol_subscription", sa.Boolean(), nullable=False),
        sa.Column("eol_sub_emailed", sa.Boolean(), nullable=False),
        sa.Column("outdated_subscription", sa.Boolean(), nullable=False),
        sa.Column("outdated_sub_emailed", sa.Boolean(), nullable=False),
        sa.Column("subscription_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("node_version_sub")
    op.drop_table("node_flag_valid_sub")
    op.drop_table("node_flag_stable_sub")
    op.drop_table("node_flag_guard_sub")
    op.drop_table("node_flag_fast_sub")
    op.drop_table("node_flag_exit_sub")
    op.drop_table("node_down_sub")
    op.drop_table("node_bandwidth_sub")
    op.drop_table("subscription")
    op.drop_table("subscriber")
    op.drop_table("relay")
    op.drop_table("admin")
    # ### end Alembic commands ###
